.H 1 "Globals Window"
The Globals window is a Frame window that evaluates C expressions in
the global name space of a process.
Its menu bar contains a menu that lists all the global variables.
.P
Unlike Frame windows, which are automatically closed when their
activation records are no longer on the stack,
the Globals window exists for the lifetime of a process and
may be used before the first instruction is executed.
This feature may be used to alter data in the data segment of
a process before it starts.
.H 2 "Globals Layout"
The title bar identifies the window and
displays the process id number or name of the core file.
The lines within the window are in the same format as lines found
in Frame windows.
.H 2 "Globals Menu Bar"
.VL 10 1
.LI "spies"
Re-evaluate and redisplay all the spy expressions in the window.
This is equivalent to the "changed spies" entry in a Frame window's "frame"
menu.
This button is not present when a core dump is examined.
.LE 
.P
The "vars" menu contains the following entries:
.VL 15 1
.LI "all"
Display all of the global variables.
This is equivalent to selecting all the other entries in the "vars" menu.
.LI "variable Glb"
A menu entry in this format appears for each global variable in
the symbol table.
Selecting a variable's entry causes that
variable to be displayed on a new line in the window.
These entries are equivalent to the "variable storage_class" entries
in a Frame window's menu, except the storage class field is always Glb.
The entries are alphabetically sorted in the menu.
.LE
.P
The "regs" menu contains the following entries:
.VL 10 1
.LI "all"
Display all of the registers.
This is equivalent to selecting all the other entries in the "regs" menu.
.LI "$regname"
As in Frame windows, there will be an entry in this format for
each processor register.
The register names depend on the machine's architecture and
can be found in the "Processor Dependencies" section.
Selecting an entry displays the current value of that register,
and is equivalent to selecting it in the Frame
window for the most recent activation record on the stack.
.LE
.P
Global variables from files without the -g option make it into
the "vars" menu, but they usually have incorrect type information.
The symbol table will claim their type is int or long, even if they are not.
If you know a variable's correct type you can use the casting operators
(see "Casting") to force pi to override the type information extracted
from the symbol table.
.H 2 "Globals Line Menus"
Lines in the Globals window generates the same menus and
accepts the same keyboard expressions as Frame windows,
except the search for identifiers starts in the global name space.
See "Frame Lines".
